Unit General;
{$define mac}
interface
  Uses Crt,Dos,graph;
  Var
           Regs:Registers;
       Pagesize:Word;

  Procedure Beep;
  PROcedure VideoMode(vmode:byte);
  Procedure ClearBuffer;
  Procedure CharReady(VAR CH:CHAR;VAR FK:Boolean);
  Function CardType: Byte;
  Function EGAMem: Word;
  Procedure CursOffScreen(Page:Byte);
  Procedure CursOff;
  Procedure CursOn;
  Procedure CursSize(Top,Bottom:Integer);
  Function GetChar(Page:Byte):CHAR;
  Function PrinterReady:Boolean;
  Function ADriveOK:Boolean;
  Function BDriveOK:Boolean;
  Procedure CursXY(Page,Column,Row:Byte);
  Function WhereCursX(Page:Byte):Byte;
  Function WhereCursY(Page:Byte):Byte;
  Function PageOffset:word;
  Procedure SetPage(Page:Byte);
  Procedure WritePage(Txt:String; Page,Col,Row,Color:Byte);
  Procedure Write132(Txt:String; Col,Row,Color:Byte);
  Procedure ClearPage(Page,Color:Byte);
  Procedure Clear132(Color:Byte);
Implementation
{ͻ
  Here are some useful general procedures and functions for Turbo 5.  
 ͼ}

{***************************************************************************}
PROCEDURE Beep;
{Less irritating than CHR(7)}
BEGIN
  Sound(100);
  Delay(100);
  NoSound;
END;{Beep}
{***************************************************************************}
PROCEDURE Videomode(Vmode:Byte);
BEGIN
  Regs.AH:=$00;
  Regs.AL:=Vmode;
  Intr($10,Regs);
END;{Vidmode}
{***************************************************************************}
PROCEDURE ClearBuffer;
{Clears the Keyboard Buffer. Useful where typing can get too far
 ahead of the program or after an error }
VAR
  ZF:Word;
BEGIN
  Regs.AH:=$01;
  Intr($16,Regs);              {Test Keyboard Buffer}
  ZF:=(Regs.Flags AND Fzero);  {Check Zero Flag}
  WHILE ZF=0 DO
  BEGIN
    Regs.AH:=$00;
    Intr($16,Regs);            {Read Char from Keyboard Buffer}
    Regs.AH:=$01;
    Intr($16,Regs);            {Test Keyboard Buffer}
    ZF:=(Regs.Flags AND Fzero)
  END;{While}
END;{ClearBuffer}
{****************************************************************************}
PROCEDURE CharReady(VAR CH:CHAR;VAR FK:Boolean);
{Examine the keyboard buffer without removing a waiting Char. Return #255 in
 CH if nothing there, FK set to TRUE if FunctionKey waiting}
VAR
  ZF:Word;
  A,B:Byte;
BEGIN
  FK:=FALSE;
  CH:=#255;
  Regs.AH:=$01;
  Intr($16,Regs);              {Test Keyboard Buffer}
  A:=Regs.AL;
  B:=Regs.AH;
  ZF:=(Regs.Flags AND Fzero);  {Check Zero Flag}
  IF ZF=0 THEN {Something is waiting}
  BEGIN
    IF A<>0 THEN CH:=CHR(A)
    ELSE
    BEGIN
      CH:=CHR(B);
      FK:=TRUE;
    END;
  END;
END;{CharReady}
{****************************************************************************}
FUNCTION CardType: Byte;
{Determines the Display card present. Adapted from Turbo Pascal Express
 by Robert Jourdain. Returns 0:MDA or HGA, 1:CGA or 2:EGA}
VAR
 I:BYTE;
BEGIN
  Regs.AX:=$40;     {Check the EGA memory byte, returned in BL.}
  Regs.ES:=Regs.AX; {BL=0:  64k.}
  REgs.AH:=$12;     {BL=1: 128k}
  Regs.BL:=$10;     {BL=2: 192k}
  Intr($10,Regs);   {BL=3: 256k}
  I:=Regs.BL;       {BL>3: Not EGA}
  IF I<=3 THEN
  BEGIN
    CardType:=2;
    EXIT;
  END;
  Regs.AH:=$0F;     {Check the current mode,returned in AL}
  Intr($10,Regs);   {AL=7: MDA or HGA text mode}
  I:=Regs.AL;       {ELSE the adaptor must be CGA}
  IF I=7 THEN CardType:=0 ELSE CardType:=1;
END;{CardType}
{****************************************************************************}
FUNCTION EGAMem: Word;
{Determines the amount of memory on an EGA. Adapted from Turbo Pascal Express
 by Robert Jourdain. Returns 0 if not EGA or the No of k of memory}
VAR
 I:BYTE;
BEGIN
  IF CardType<>2 THEN
  BEGIN
    EGAMem:=0;
    Exit;
  END;
  Regs.AX:=$40;     {Check the EGA memory byte, returned in BL.}
  Regs.ES:=Regs.AX; {BL=0:  64k.}
  REgs.AH:=$12;     {BL=1: 128k}
  Regs.BL:=$10;     {BL=2: 192k}
  Intr($10,Regs);   {BL=3: 256k}
  I:=Regs.BL;       {BL>3: Not EGA}
  CASE I OF
  0:EGAMem:=64;
  1:EGAMem:=128;
  2:EGAMem:=192;
  3:EGAMem:=256;
  ELSE EGAMem:=0;
  END;{Case}
END;{EGAMem}
{***************************************************************************}
PROCEDURE CursOffScreen(Page:Byte);
{Sends the cursor off screen without changing its shape}
BEGIN
  IF CardType=0 then Page:=0;
  Regs.AH:=$02;
  Regs.BH:=Page;
  Regs.DH:=26;
  Regs.DL:=1;
  Intr($10,Regs);
END;{CursOffScreen}
{***************************************************************************}
PROCEDURE CursOff;
{Turns the text cursor off by setting its top >13. You must restore the
 cursor with a call to CursOn or CursSize before your program ends.}
BEGIN
  Regs.AH:=$01;
  Regs.CH:=$E;
  Regs.CL:=$0;
  Intr($10,Regs);
END;{CursOff}
{***************************************************************************}
PROCEDURE CursOn;
{Turns the Text Cursor On and restores the standard size. May have to
 be modified for some versions of DOS and particular adapters}
BEGIN
  Regs.AH:=$01;
  Regs.CH:=6;
  Regs.CL:=7;
  Intr($10,Regs);
END;{CursOn}
{***************************************************************************}
PROCEDURE CursSize(Top,Bottom:Integer);
{Top and Bottom can be 0 to 7 for CGA and 0 to 13 for EGA,MDA.
 Actual cursor is machine dependent, so you may have to play with this. }
BEGIN
  Regs.AH:=$01;
  Regs.CH:=Top;
  Regs.CL:=Bottom;
  Intr($10,Regs);
END;{CursSize}
{***************************************************************************}
FUNCTION GetChar(Page:Byte):CHAR;
{Returns the character at the present cursor positon on a given page}
BEGIN
  If CardType=0 then Page:=0;
  Regs.AH:=$08;
  Regs.BH:=Page;
  Intr($10,Regs);
  GetChar:=CHR(Regs.AL);
END;{GetChar}
{***************************************************************************}
Function PrinterReady:Boolean;
VAR
  I:byte;
Begin
  Regs.AH:=$02;
  Regs.DX:=$00;
  Intr($17,Regs);
  I:=Regs.AH;
  IF I<>144 {10010000} THEN PrinterReady:=False else PrinterReady:=True;
  {For Laser Printer Other Errors
    8 {00001000 = offline or turned off
   40 {00101000 = out of paper
   48 {00110000 = cable disconnencted}
end;
{***************************************************************************}
Function ADriveOK:Boolean;
begin
  Regs.AH:=$36;
  Regs.DL:=1;
  Intr($21,Regs);
  IF regs.AX=$FFFF then ADriveOK:=False else AdriveOK:=TRUE;
end;
{***************************************************************************}
Function BDriveOK:Boolean;
begin
  Regs.AH:=$36;
  Regs.DL:=2;
  Intr($21,Regs);
  IF regs.AX=$FFFF then BDriveOK:=False else BdriveOK:=TRUE;
end;
{***************************************************************************}

{ͻ
  Turbo 5.0 does not provide for using extra video pages in text mode.     
  Here are a series of procedures for using the extra pages. You must have 
  a CGA or EGA for them to be useful. When used with Page 0, they simply   
  duplicate Turbo procedures. There are 3 extra pages with the CGA and     
  up to 7 with the EGA depending on memory.                                
 ͼ}
{***************************************************************************}
PROCEDURE CursXY(Page,Column,Row:Byte);
{Position the text cursor on any video page. If call is off screen
 no action is taken.}
BEGIN
  If CardType=0 THEN Page:=0;
  Regs.AH:=$02;
  Regs.BH:=Page;
  Regs.DH:=Row-1;
  Regs.DL:=Column-1;
  Intr($10,Regs);
END;{CursXY}
{***************************************************************************}
FUNCTION WhereCursX(Page:Byte):Byte;
{Returns the column containing the cursor on a given video page}
BEGIN
  If CardType=0 THEN Page:=0;
  Regs.AH:=$03;
  Regs.CH:=Page;
  Intr($10,Regs);
  WhereCursX:=Regs.DL+1;
END;{WhereCursX}
{***************************************************************************}
FUNCTION WhereCursY(Page:Byte):Byte;
{Returns the column containing the cursor on a given video page}
BEGIN
  If CardType=0 THEN Page:=0;
  Regs.AH:=$03;
  Regs.CH:=Page;
  Intr($10,Regs);
  WhereCursY:=Regs.DH+1;
END;{WhereCursY}
{****************************************************************************}
PROCEDURE SetPage(Page:Byte);
{Switches monitor to a different video page. Page=0-3 for CGA or 0-7 for EGA}
BEGIN
  If CardType=0 THEN Exit;
  If ((CardType=1) OR (EGAMem=0)) AND (Page>3) THEN Exit;
  IF Page>7 THEN Exit;
  Regs.AH:=$05;
  Regs.AL:=Page;
  Intr($10,Regs);
END;{SetPage}
{****************************************************************************}
Function PageOffset:word;
begin
  setpage(1);
  pageoffset:=memw[$0000:$044e];
  setpage(0);
end;
{****************************************************************************}
PROCEDURE WritePage(Txt:String; Page,Col,Row,Color:Byte);
{Writes a string at any position on any video page with any color in the
 current palette. Strings which are too long are truncated, not wrapped. No
 action if position is illegal. For speed this procedure writes directly to
 video buffer starting at: $B000:0000 for MDA or $B800:0000 for CGA or EGA.
 Numbers have to be convert to strings before the call}
VAR
  Card,j:integer;
  MaxRow,Pgsz,X,Y:Word;
  Z:Byte;
BEGIN
  Detectgraph(Card,j);

  pgsz:=pagesize div $10;
  If (card=VGA) and (lastmode>256) then MaxRow:=50
  else if (card=EGA) and (Lastmode>256) then MaxRow :=43
  else Maxrow :=25;
  IF (Col>80) OR (Col<1) OR (Row<1) OR (Row>MaxRow) then Exit;


  (*IF CardType>0 THEN X:=$B800+(Page*pagesize)
  ELSE {MDA/HGA}
  BEGIN
    X:=$B000;
    Page:=0;
  END;{Else}
  *)

  X:=$B800+(page*pgsz);

  If Txt<>'#Clear#' then
  begin
    Y:=2*((Row-1)*80 + Col)-2; {Starting Position}
    Z:=1;
    While (Col<81) AND (Z<=Length(Txt)) DO
    BEGIN
      Mem[X:Y]:=ORD(Txt[Z]);
      Mem[X:Y+1]:=Color;
      Inc(Z);
      Inc(Col);
      Y:=Y+2;
    END;{While}
  end
  else {clear page}
  begin
    For Y:=0 TO 80*maxrow-1  DO
    begin
      Mem[X:2*Y]:=32;
      Mem[X:2*Y+1]:=Color;
    end;
  end;

END;{WritePage}
{****************************************************************************}
PROCEDURE Write132(Txt:String; Col,Row,Color:Byte);
{for use with videomode $37}
VAR
  X,Y,Z:Byte;

BEGIN

  IF (Col>132) OR (Col<1) OR (Row<1) OR (Row>48) then Exit;

  {Set cursor}
  regs.ah:=2;
  regs.bh:=0;
  regs.dh:=row-1;
  regs.dl:=col-1;
  intr($10,regs);

  X:=ORD(txt[0]);
  if X>132 then x:=132;
  for y:=1 to x do
  begin
    regs.AH:=14;
    regs.al:=ord(txt[y]);
    regs.bl:=color;
    regs.bh:=0;
    intr($10,regs);
  end;

END;{Write132}

{****************************************************************************}
PROCEDURE ClearPage(Page,Color:Byte);
{Clears any video page in any color. For speed this procedure writes directly
 to video buffer starting at:$B000:0000 for MDA or $B800:0000 for CGA or EGA.}
VAR
  X,Y:Word;
  Z:Byte;
BEGIN
  IF CardType>0 THEN X:=$B800+(Page*$100) {CGA/EGA}
  ELSE {MDA/HGA}
  BEGIN
    X:=$B000;
    Page:=0;
  END;
  For Y:=0 TO 1999 DO Mem[X:2*Y]:=32;
  For Y:=0 TO 1999 DO Mem[X:2*Y+1]:=Color;
END;{ClearPage}
{****************************************************************************}
PROCEDURE Clear132(Color:Byte);
VAR
  X,Y:Byte;
BEGIN
  for y:=0 to 50 do
  begin
    {Set cursor}
    regs.ah:=2;
    regs.bh:=0;
    regs.dh:=0;
    regs.dl:=y;
    intr($10,regs);

    regs.ah:=9;
    regs.al:=$0;
    regs.bh:=0;
    regs.bl:=color;
    regs.cx:=132;
  end;
END;{ClearPage}
{****************************************************************************}
End.